import com.siemens.mp.io.*;
import com.siemens.mp.game.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * Implements a Infrared remote control to use as you want...
 * @see com.siemens.mp.io.Connection
 * @see com.siemens.mp.io.ConnectionListener
 */
public class Remote extends MIDlet implements ConnectionListener, CommandListener
{  Connection conn;
   Form form;
   long seed;
   TextField txtURL;
   StringItem txtData;

   protected void destroyApp(boolean b)
   {  conn = null;
      this.notifyDestroyed();
   }

   protected void pauseApp()
   {  }

   /**
    * Called when the MIDLet starts
    */
   protected void startApp()
   {  seed = 86028113;  // A Random prime number
      txtURL = new TextField ("URL", "IRDA:", 20, TextField.URL);
      txtData = new StringItem ("Data sent", "");
      form = new Form ("DarkWan Remote", new Item[] {txtURL, txtData});
      form.setCommandListener (this);
      Command cmd = new Command("Quit", Command.EXIT, 0);
      form.addCommand(cmd);
      cmd = new Command("Vibra", Command.SCREEN, 1);
      form.addCommand(cmd);
      cmd = new Command("Beep", Command.SCREEN, 2);
      form.addCommand(cmd);
      cmd = new Command("Connect", Command.SCREEN, 3);
      form.addCommand(cmd);
      Display.getDisplay(this).setCurrent (form);
   }

   /**
    * @see CommandListener
    */
   public void commandAction(Command cmd, Displayable dsp)
   {  if (cmd.getLabel().equals ("Quit"))
         destroyApp(true);
      else if (cmd.getLabel().equals ("Vibra"))
         Vibrator.triggerVibrator(1000);
      else if (cmd.getLabel().equals ("Beep"))
         Sound.playTone (getRandom(128), getRandom(128));
      else if (cmd.getLabel().equals ("Connect"))
      {  conn = null;
         conn = new Connection(txtURL.getString());
         conn.setListener(this);
      //   for (int i=0; i<getRandom(1000)+1; i++)
         {  // IrDA protocol needed!!
            byte[] byteArray = new byte[] {(byte)getRandom(250),(byte)getRandom(128),
                                           (byte)getRandom(255),(byte)getRandom(192),
                                           (byte)getRandom(192),(byte)getRandom(190),
                                           (byte)getRandom(254),(byte)getRandom(250)};
      //      txtData.setString("Cont=" + i);
            txtData.setText(new String (byteArray));
            try
            {  conn.send (byteArray);
            }  catch (com.siemens.mp.NotAllowedException nae)
               {  Alert alert = new Alert ("Error", "NotAllowedException", null, AlertType.INFO);
                  alert.setTimeout(5000);
                  Display.getDisplay(this).setCurrent(alert, form);
               }
         }
      }
   }

   /**
    * I tryed to receive data from a real TV remote control
    * But nothing goes.
    * @param data Data read from IrDA beam
    * @see ConnectionListener
    */
   public void receiveData(byte[] data)
   {  String dati = new String (data);
      Alert alert = new Alert ("I GOT IT!", dati, null, AlertType.INFO);
      alert.setTimeout(5000);
      Display.getDisplay(this).setCurrent(alert, form);
      try
      {  conn.send (data);
      }  catch (com.siemens.mp.NotAllowedException nae)
         {  alert = new Alert ("Error", "NotAllowedException", null, AlertType.INFO);
            alert.setTimeout(5000);
            Display.getDisplay(this).setCurrent(alert, form);
         }
   }

   /**
    * @param max The upper value in the range
    * @return A random number beetween 0 and max
    * #see java.util.Random
    * @see System.currentTimeMillis
    */
   protected int getRandom (int max)
   {  seed = Math.abs(seed + System.currentTimeMillis());
      System.out.println (seed);
      return (int)(seed % max);
   }
}
